% 13 mars 2020
/rack-pinionIIID {
50 dict begin
/Pi 3.14159265359 def
/rad2deg { 180 mul Pi div } bind def
/deg2rad { 180 div Pi mul } bind def
/Tan { dup sin exch cos div } def
/DatasCremaillere {
/pas Pi m1 mul def
/r0 0.38 m1 mul  def
/xA {m1 Pi 4 div ap Tan sub mul pas i1 mul add } def
/yA 0 def
/xB {m1 Pi 4 div mul pas i1 mul add } def
/yB m1  def
/xC {m1 Pi 4 div ap Tan add mul pas i1 mul add} def
/yC 2 m1 mul  def
/xD {m1 3 Pi mul 4 div ap Tan sub mul pas i1 mul add  } def
/yD 2 m1 mul  def
/xE {3 Pi mul 4 div m1 mul pas i1 mul add  } def
/yE m1  def
/xF {m1 3 Pi mul 4 div ap Tan add mul pas i1 mul add  } def
/yF 0 def
/xG {m1 Pi mul pas i1 mul add  } def
/yG 0 def
/xO'1 {m1 Pi 4 div ap Tan add 0.38 ap cos mul add mul pas i1 mul add  } def
/yO'1 1.87 m1 mul  def
/xO'2 {m1 3 Pi mul 4 div ap Tan sub 0.38 ap cos mul sub mul pas i1 mul add  } def
/yO'2 1.87 m1 mul  def
/xC' {xO'1} def
/yC' 2.25 m1 mul  def
/xD' {xO'2} def
/yD' 2.25 m1 mul  def
/epaisseur 7.5 m1 mul  def
} def
% pour la roue dente
/Datas1 {
         /Z@ exch def
         /m@ exch def
         /R@ {m@ Z@ mul 2 div } bind def % cercle primitif
         /Rb {R@ ap cos mul } bind def % cercle de base
         /Rp {R@ 2 mul 2.5 m@ mul sub 2 div } bind def % cercle de pied
         /Rt {R@ 2 mul 2 m@ mul add 2 div } bind def % cercle de tte
         } def
/Calculs {
         % les valeurs suivantes sont en radians
         /ThetaP {R@ Rb div dup mul 1 sub sqrt } bind def % intersection avec cercle primitif
         /ThetaT {Rt Rb div dup mul 1 sub sqrt } bind def % intersection avec cercle de tete
         % Les valeurs suivantes ont en degrs
         /ThetaTdeg {Rt Rb div dup mul 1 sub sqrt rd} bind def %
         /ThetaPdeg {R@ Rb div dup mul 1 sub sqrt rd} bind def
         /DeltaP {ThetaPdeg sin ThetaP ThetaPdeg cos mul sub
                  ThetaPdeg cos ThetaP ThetaPdeg sin mul add
                  atan } bind def
         /DeltaT {ThetaTdeg sin ThetaT ThetaTdeg cos mul sub
                  ThetaTdeg cos ThetaT ThetaTdeg sin mul add
                  atan } bind def
         /DeltaS {Pi 2 div Z@ div } bind def
         /DeltaSdeg {90 Z@ div } bind def
         /AngleDent {360 Z@ div} bind def
         /ALPHA {DeltaSdeg DeltaP add DeltaT sub } bind def
         /2Beta {DeltaSdeg DeltaP add 2 mul } bind def
         /Beta_  {DeltaSdeg DeltaP add neg} bind def
          Rp Rb gt {/Rp Rb def} if
         /ptA {Rp 0} bind def
         /ptB {Rb 0} bind def
         /ptC {Rp DeltaSdeg 2 mul neg 2Beta 2 div add cos mul
               Rp DeltaSdeg 2 mul neg 2Beta 2 div add sin mul} bind def
         /ptA'{Rp DeltaP DeltaSdeg add 2 mul cos mul
               Rp DeltaP DeltaSdeg add 2 mul sin mul} bind def
         /ptB'{Rb DeltaP DeltaSdeg add 2 mul cos mul
               Rb DeltaP DeltaSdeg add 2 mul sin mul} bind def
         /ptC'{Rp DeltaSdeg 3 mul DeltaP add cos mul
               Rp DeltaSdeg 3 mul DeltaP add sin mul} bind def
         /Raxe {Rp 4 div } bind def
         /A@0 14.5 def % position et largeur de la clavette
% rayon de raccordement sur le cercle de pied
         /Rarct {Rp Pi mul Z@ div facteurRayonRaccord cm} bind def
         }
         def
% Le symetrique P' de P par rapport a la l'axe de la dent
% Delta(axe de la dent) y=x*tan(Beta)
% x'=y*sin(2*Beta)+x*cos(2*Beta)
% y'=x*sin(2*Beta)-y*cos(2*Beta)
% x y symAxe -> x' y'
/symAxe {
 2 dict begin
  /y exch def
  /x exch def
  y 2Beta sin mul x 2Beta cos mul add % x'
  x 2Beta sin mul y 2Beta cos mul sub % y'
 end
 }
 def
 %
% Rotation pour amener l'axe de la dent horizontal
%
/RotDent {
 2 dict begin
/y exch def
/x exch def
 i@ cos x mul i@ sin y mul sub
 i@ sin x mul i@ cos y mul add
end
} def
%
% developpante du cercle de base
 /devCercle {
  1 dict begin
  /t exch def % en degres
  Rb t cos t deg t sin mul add mul % x
  Rb t sin t deg t cos mul sub mul % y
 end
 }
 def
%
/Roue2D {
 % arc de dveloppante
/tabArcDev [
0 1 ThetaTdeg { /i@ exch def
 [i@ devCercle] } for
 ] def
 %
/n@ tabArcDev length def
/tabDent [
% l'arc de developpante initial
  tabArcDev aload pop
% l'arc ce cercle de tete
DeltaT 0.1 2Beta DeltaT sub {/i exch def
 [Rt i cos mul
  Rt i sin mul]
 } for
% le symetrique de l'arc de developpante par rapport a l'axe de la dent
n@ 1 sub -1 0  {
    /compteur exch def
    [tabArcDev compteur get aload pop symAxe]
    } for
    ] def
%%%
/n2@ tabDent length def
/ContourDent2D  [
ptC
0 1 Z@ 1 sub {/i@ exch AngleDent mul def
ptC RotDent
ptA RotDent
0 1 n2@ 1 sub {
    /compteur exch def
    tabDent compteur get aload pop
    RotDent
    } for
ptA' RotDent
ptC' RotDent
} for
] def
    0 wheelwidth % hauteur =z1-z0
    0 0 1 % axe // Oz
   /u defpoint3d
   /z1 exch def
   /z0 exch def
   %% N = nb d etages
   /N ngrid 0 get def
   /table ContourDent2D def
   %% n = indice du dernier point
   /n  ContourDent2D length 2 idiv 1 sub def
   %% vecteur de translation
   u
   z1 z0 sub u norme3d div
   mulv3d /v defpoint3d
   %% tableau des sommets
   /S [
      0 1 N {
         /j exch def
         0 1 n {
             /i exch def
             table i getp neg
             z0
             v N j sub N div mulv addv3d exch
         } for
      } for
   ] def
   /F [
%% on conserve la face 0 ?
 %    [0 1 n {} for] reverse
     [1 1 n {} for]
%%   on conserve la face 1
      [N 1 add n 1 add mul 1 sub -1 N n 1 add mul {} for]
      %% faces etage
      1 1 N {
         /j exch def
         1 1 n {
             /i exch def
             [i                   j 1 sub n 1 add mul add
              i 1 sub             j 1 sub n 1 add mul add
              n 1 add i add 1 sub j 1 sub n 1 add mul add
              n 1 add i add       j 1 sub n 1 add mul add]
         } for
     } for
   ] def
   S F generesolid
   /Roue3D exch def
  ContourDent2D reversep
    /table exch def
   /n table length 2 idiv def
   /S [
  0 1 n 1 sub {/i exch def
    table i getp neg
    z0
    exch
    } for
     ] def
   /F [
       [1 1 n 1 sub {} for]
   ] def
   S F generesolid
      dup videsolid
   /ContourSup exch def
   } def
  m1 Z1 Datas1 Calculs
Roue2D
Roue3D
%   dup {Beta_ AngleRotation sub 0 0 rotateOpoint3d} solidtransform
   dup {0 Beta_  180 Z1 div add 90 add AngleRotation add 0 rotateOpoint3d} solidtransform
   /LaRoue exch def
%gere_pstricks_opt
ContourSup
%   dup {Beta_ AngleRotation sub 0 0 rotateOpoint3d} solidtransform
   dup {0 Beta_  180 Z1 div add 90 add AngleRotation add 0 rotateOpoint3d} solidtransform
   dup {RotX RotY RotZ rotateOpoint3d} solidtransform
   dup {CX CY CZ translatepoint3d} solidtransform
/ContourRoue exch def
%%=== calcul des caracteristiques de la cremaillere ======
 DatasCremaillere
 /tabCremaillere [
 0 epaisseur
 0 1 Z2 1 sub {/i1 exch def
 /xO pas i1 mul def /yO 0 def
% [xO  0]
  0 0.1 1 {/k exch def
    xO xA xO sub k mul add
    yO yA yO sub k mul add
    } for
% [xA yA][xB yB][xC yC]
 0 0.1 1 {/k exch def
    xA xC xA sub k mul add
    yA yC yA sub k mul add
    } for
 180 ap sub -1 90 {/i2 exch def
    xO'1 r0 i2 cos mul add
    yO'1 r0 i2 sin mul add
    } for
% [xC' yC'][xD' yD']
  0 0.1 1 {/k exch def
    xC' xD' xC' sub k mul add
    yC' yD' yC' sub k mul add
   } for
 90 -1 ap {/i2 exch def
 xO'2 r0 i2 cos mul add
 yO'2 r0 i2 sin mul add
    } for
 0 0.1 1 {/k exch def
     xD xF xD sub k mul add
     yD yF yD sub k mul add
    } for
 0 0.1 1 {/k exch def
     xF xG xF sub k mul add
     yF yG yF sub k mul add
    } for
 } for
 xG yG
 xG epaisseur
 ] def
%
 /n tabCremaillere length 2 idiv 1 sub def
    0 0 1 % axe // Oz
   /z0 0 def
   /z1 wheelwidth def
   z1 z0 sub 0 0 1 norme3d div
   mulv3d /v defpoint3d
   /N ngrid 0 get def
   /S [
      0 1 N {
         /j exch def
         0 1 n {
             /i exch def
             tabCremaillere i getp neg
             z0
             v N j sub N div mulv addv3d exch
         } for
      } for
   ] def
   /F [
%% on conserve la face 0 ?
     [0 1 n 1 sub {} for]
%%   on conserve la base
      [N 1 add n 1 add mul 1 sub -1 N n 1 add mul {} for]
      %% faces etage
      1 1 N {
         /j exch def
         1 1 n {
             /i exch def
             [i                   j 1 sub n 1 add mul add
              i 1 sub             j 1 sub n 1 add mul add
              n 1 add i add 1 sub j 1 sub n 1 add mul add
              n 1 add i add       j 1 sub n 1 add mul add]
         } for
     } for
   ] def
   S F generesolid
   dup {Z2 neg pas mul 2 div cm AngleRotation deg2rad R@ cm mul sub 0 R@ neg m1 add cm  translatepoint3d} solidtransform
/LaCremaillere exch def
/AXE {
    0 m1 Z1 mul 7.5 div 1 cm
     [1 36]
      newcylindre
    dup {90 0 0 rotateOpoint3d} solidtransform
} def
LaRoue LaCremaillere  solidfuz
gere_pstricks_opt
% pour dessiner le contour des dents
tabCremaillere reversep
    /table exch def
   /n table length 2 idiv def
   /S [
  0 1 n 1 sub {/i exch def
    table i getp neg
    z0
    exch
    } for
     ] def
   /F [
       [0 1 n 1 sub {} for]
   ] def
   S F generesolid
%  /contourCremaillere exch def
%   contourCremaillere
    {Z2 neg pas mul 2 div cm AngleRotation deg2rad R@ cm mul sub 0 R@ neg m1 add cm translatepoint3d} solidtransform
    {RotX RotY RotZ rotateOpoint3d} solidtransform
    {CX CY CZ translatepoint3d} solidtransform
   /contourCremaillere exch def
   contourCremaillere
   dup (fillincolor) outputcolors
/solidgrid true def
   drawsolid**
%  contourCremaillere
%   drawsolid
ContourRoue
   dup (fillincolor) outputcolors
   drawsolid**
%ContourRoue
%   drawsolid
  AXE
  /solidgrid false def
    /fcol [0 (axiscolor)] def
  dup (fillincolor) outputcolors
gere_pstricks_opt
end
  } def
%
/pst-rackpinion {
%   m1 Z1 Z2 wheelwidth
  rack-pinionIIID
  }
  def
